<template>
  <app-dialog
    v-model="visible"
    :show-loading-icon="submitLoading"
    :title="title"
  >
    <template #content>
      <div class="pl-6 pb-6">
        <div class="mb-6 flex gap-4 items-center">
          <el-button
            class="btn btn--primary btn--md"
            :disabled="data.length"
            :loading="importLoading"
            @click="open"
          >
            Select File
          </el-button>
          <el-button
            class="btn btn--bordered btn--md"
            :disabled="!data.length"
            @click="() => resetImport()"
          >
            Reset
          </el-button>
          <div class="badge badge--green text-center text-lg pt-4">
            <span>Lines parsed: {{ data.length }}</span>
          </div>
          <div
            v-if="parseErrors.length"
            class="badge badge--red text-center text-lg pt-4"
          >
            <span>Errors: {{ parseErrors.length }}</span>
          </div>
        </div>
      </div>
      <div class="bg-gray-50 rounded-b-md flex items-center justify-end py-4 px-6">
        <el-button
          class="btn btn--bordered btn--md mr-3"
          @click="visible = false"
        >
          Cancel
        </el-button>
        <el-button
          class="btn btn--primary btn--md"
          :loading="submitLoading"
          :disabled="!data.length"
          @click="handleSubmit"
        >
          Import
        </el-button>
      </div>
    </template>
  </app-dialog>
</template>

<script setup>

import {
  defineProps,
  defineEmits,
  computed,
  ref,
  watch,
} from 'vue';
import { useFileDialog } from '@vueuse/core';
import { CsvParser } from '@/shared/csv/csv';
import Message from '../message/message';

const props = defineProps({
  modelValue: {
    type: Boolean,
    default: false,
  },
  importAction: {
    type: Function,
    default: null,
  },
  title: {
    type: String,
    default: 'Import Data',
  },
  proccessRow: {
    type: Function,
    default: null,
  },
});
const emit = defineEmits('update:modelValue');

const {
  files, open, reset,
} = useFileDialog({
  accept: '.csv',
  multiple: false,
});

const loading = ref(false);
const importLoading = ref(false);
const submitLoading = computed(() => loading.value || importLoading.value);
const data = ref([]);
const parseErrors = ref([]);
let header = [];

const onParsingComplete = (data) => {
  parseErrors.value = data.errors;
  importLoading.value = false;
};

const resetImport = () => {
  data.value = [];
  parseErrors.value = [];
  loading.value = false;
  importLoading.value = false;
  reset();
};

const generateRandomSecret = (length) => {
  const array = new Uint8Array(length);
  window.crypto.getRandomValues(array);
  return Array.from(array).map((b) => b.toString(16).padStart(2, '0')).join('');
};

const parseRow = (row) => {
  if (!header.length) {
    header = row.data;
    return;
  }

  let mappedRow = {};
  if (props.proccessRow) {
    mappedRow = props.proccessRow(header, row.data);
  } else {
    header.forEach((x, index) => {
      try {
        mappedRow[x] = JSON.parse(row.data[index]);
      } catch (ex) {
        mappedRow[x] = row.data[index];
      }
    });
  }

  mappedRow.importHash = generateRandomSecret(16);
  data.value.push(mappedRow);
};

const onFileSelected = (files) => {
  const file = files && files[0];
  if (file) {
    importLoading.value = true;
    const reader = new FileReader();
    reader.onabort = () => {
      Message.error(null, {
        title: 'file reading was aborted',
      });
    };
    reader.onerror = () => {
      Message.error(null, {
        title: 'file reading has failed',
      });
    };
    reader.onload = () => {
      try {
        CsvParser.parse(reader.result, { header: false, complete: (data) => onParsingComplete(data), step: parseRow });
      } catch (e) {
        Message.error(null, {
          title: e,
        });
      }
    };
    reader.readAsText(file);
  }
};

const handleSubmit = async () => {
  loading.value = true;
  props.importAction(data.value, (exception) => {
    if (exception) {
      Message.error(null, {
        title: exception,
      });
    }
    loading.value = false;
  });
  loading.value = true;
};

watch(() => files.value, (newValue) => {
  onFileSelected(newValue);
});

const visible = computed({
  get() {
    return props.modelValue;
  },
  set(value) {
    resetImport();
    return emit('update:modelValue', value);
  },
});
</script>
